# [*Probabilistic Graphical Models*](http://www.di.ens.fr/~slacoste/teaching/MVA_GM/fall2015/) project (Master MVA)
## Meta-data:
- Sujet: **HSMM (Hidden Semi-Markovian models)**,
- Contact: [Guillaume Obozinski](http://imagine.enpc.fr/~obozinsg/teaching.html) (Guillaume.Obozinski at imagine.enpc.fr),
- Keywords: HMM, Markov Chain, HSMM,
- Reference: http://www.di.ens.fr/~slacoste/teaching/MVA_GM/fall2015/index_projects.html,
- Where: [git repository on bitbucket.org](https://bitbucket.org/lbesson/mva15-project-probabilistic-graphical-models),
- Application: signal (audio or video) recognition, real-time audio processing.

## Description:
HSMM (Hidden Semi-Markovian models). A class of models allowing to model the time spent in any given state for a Markov Chain and an HMM.

- Wikipedia pages: [Hidden Markov Models](https://en.wikipedia.org/wiki/Hidden_Markov_model), [Hidden semi-Markov Models](https://en.wikipedia.org/wiki/Hidden_semi-Markov_model).
- [More links here](http://www.cs.ubc.ca/~murphyk/Software/HMM/hmm.html).

----

# Main documents
## [Poster](./poster/) (DONE)
> 1-page poster for the oral presentation on 09-01-2016.
> [See the poster](https://bitbucket.org/lbesson/mva15-project-probabilistic-graphical-models/downloads/MVA_PGM__project_HSSM__Besson_Brunck__Poster_06-01-2016.pdf).

## [Final report](./report/) (DONE)
> 5-10-page projet report, due to 13-01-2016.
> [See the report](https://bitbucket.org/lbesson/mva15-project-probabilistic-graphical-models/downloads/MVA_PGM__project_HSSM__Besson_Brunck__Final_report.pdf).

----

### More references
#### On HMM
- [These slides in French](https://perso.limsi.fr/Individu/allauzen/cours/cours12_13/ASO/cours_HMM.pdf#page=53),
- Wikipédia pages in French : [HSMM](https://fr.wikipedia.org/wiki/Mod%C3%A8le_de_Markov_cach%C3%A9), [Algo de Viterbi](https://fr.wikipedia.org/wiki/Algorithme_de_Viterbi), [Algo de Baum-Welch](https://fr.wikipedia.org/wiki/Algorithme_de_Baum-Welch),
- Wikipédia pages in English: [Fordarw algorithm](https://en.wikipedia.org/wiki/Forward_algorithm).

#### Other references
- [Hidden Markov Models tutorial](http://digital.cs.usu.edu/~cyan/CS7960/hmm-tutorial.pdf) by Phil Blunsom.
- [Hidden Markov Models Fundamentals](http://cs229.stanford.edu/section/cs229-hmm.pdf) by Daniel Ramag.
- [Hidden Markov Models for Speech Recognition](https://www.jstor.org/stable/1268779).
- [A Tutorial on Hidden Markov Models](http://www.robots.ox.ac.uk/~vgg/rg/slides/hmm.pdf) by Marcin Marszalek.
- [A tutorial on hidden Markov models and selected applications in speech recognition](http://www.cs.ubc.ca/~murphyk/Bayes/rabiner.pdf) by Lawrence, R. Rabiner, (1989).

----

## Implementation
- First, have a look to [our implementation of HMM and HSMM](./HSMM/)
- Then, to [the experiments we did](./src/) by using [pyhsmm](https://github.com/mattjj/pyhsmm) and [hmmlearn](https://github.com/hmmlearn/hmmlearn). All the animated graphs are shown [in this document](./src/gif.md).

### References for our implementation
- [GitHub/pyhsmm](https://github.com/mattjj/pyhsmm) is quite awesome.
- [GitHub/hmmlearn](https://github.com/hmmlearn/hmmlearn) is mature, pure Python, close to scikit-learn, with documentation [hmmlearn/doc](https://hmmlearn.readthedocs.org/en/latest), see [hmmlearn/tutorial](https://hmmlearn.readthedocs.org/en/latest/tutorial.html).

----

## About
This project was done for the [Probabilistic Graphical Models](http://www.di.ens.fr/~slacoste/teaching/MVA_GM/fall2015/) course for the [MVA master program](http://www.cmla.ens-cachan.fr/version-anglaise/academics/mva-master-degree-227777.kjsp) at [ENS de Cachan](http://www.ens-cachan.fr).

### Copyright
(C), 2015-16, [Lilian Besson](http://perso.crans.org/besson/) and [Valentin Brunck](http://thesilkmonkey.com/science/science.php) ([ENS de Cachan](http://www.ens-cachan.fr)).

### Licence
This project is publicly published, under the terms of the [MIT license](http://lbesson.mit-license.org/).
